//Escrita dos valores na rede
//*********************************************************************************
void FUNC_MB_Write() {

  //Setup do inversor
  VAR_Freq_Max[0] = MOD_Freq_Max;
  VAR_Acc[0] = MOD_Acc;
  VAR_Dec[0] = MOD_Dec;

  //palavras de comando do inversor
  bitWrite(VAR_Comandos[0], 0, MOD_Move_FWD);
  bitWrite(VAR_Comandos[0], 1, MOD_Move_BWD);
  bitWrite(VAR_Comandos[0], 2, MOD_Jog_FWD);
  bitWrite(VAR_Comandos[0], 3, MOD_Jog_BWD);
  bitWrite(VAR_Comandos[0], 4, MOD_Move_STOP);
  bitWrite(VAR_Comandos[0], 5, MOD_Fast_STOP);
  bitWrite(VAR_Comandos[0], 6, MOD_Reset_ERROR);
  bitWrite(VAR_Comandos[0], 7, MOD_Jog_STOP);

  //referencia de velocidade inversor
  VAR_Speed[0] = MOD_Speed;
}

//Leitura dos valores na rede
//*********************************************************************************
void FUNC_MB_Read() {

  //Leitura da velocidade atual
  MOD_Rpm_Act = VAR_Rpm_Act[0];

  //Leitura do código de falha do inversor
  MOD_Falha = VAR_Falha[0];
}

//Controle da comunicação
//*********************************************************************************
void FUNC_MB_Loop() {
  switch (u8state) {
    //case 0: Frequência máxima  
    case 0:
      FUNC_MB_Write();
      if (MOD_Move_FWD == 0){
        Comm_MB.u8id = 1; // slave address
        Comm_MB.u8fct = 16; // function code (this one is registers write)
        Comm_MB.u16RegAdd = 3; // start address in slave
        Comm_MB.u16CoilsNo = 1; // number of elements (coils or registers) to write
        Comm_MB.au16reg = VAR_Freq_Max; // pointer to a memory array in the CPU
        master.query(Comm_MB); // send query (only once)
        u8state++;
      }else{
        u8state = 2;
      }
    break;

    case 1:
      master.poll(); // check incoming messages
      if (master.getState() == COM_IDLE) {
        u8state = 2;
      }
    break;

    //case 2: Frequência máxima  
    case 2:
      FUNC_MB_Write();
      if (MOD_Move_FWD == 0){
        Comm_MB.u8id = 1; // slave address
        Comm_MB.u8fct = 16; // function code (this one is registers write)
        Comm_MB.u16RegAdd = 4; // start address in slave
        Comm_MB.u16CoilsNo = 1; // number of elements (coils or registers) to write
        Comm_MB.au16reg = VAR_Freq_Max; // pointer to a memory array in the CPU
        master.query(Comm_MB); // send query (only once)
        u8state++;
      }else{
        u8state = 4;
      }
    break;

    case 3:
      master.poll(); // check incoming messages
      if (master.getState() == COM_IDLE) {
        u8state = 4;
      }
    break;

    //case 4: Aceleração  
    case 4:
      FUNC_MB_Write();
      if (MOD_Move_FWD == 0){
        Comm_MB.u8id = 1; // slave address
        Comm_MB.u8fct = 16; // function code (this one is registers write)
        Comm_MB.u16RegAdd = 17; // start address in slave
        Comm_MB.u16CoilsNo = 1; // number of elements (coils or registers) to write
        Comm_MB.au16reg = VAR_Acc; // pointer to a memory array in the CPU
        master.query(Comm_MB); // send query (only once)
        u8state++;
      }else{
        u8state = 6;
      }
    break;

    case 5:
      master.poll(); // check incoming messages
      if (master.getState() == COM_IDLE) {
        u8state = 6;
      }
    break;

    //case 6: Desaceleração  
    case 6:
      FUNC_MB_Write();
      if (MOD_Move_FWD == 0){
        Comm_MB.u8id = 1; // slave address
        Comm_MB.u8fct = 16; // function code (this one is registers write)
        Comm_MB.u16RegAdd = 18; // start address in slave
        Comm_MB.u16CoilsNo = 1; // number of elements (coils or registers) to write
        Comm_MB.au16reg = VAR_Dec; // pointer to a memory array in the CPU
        master.query(Comm_MB); // send query (only once)
        u8state++;
      }else{
        u8state = 8;
      }
    break;

    case 7:
      master.poll(); // check incoming messages
      if (master.getState() == COM_IDLE) {
        u8state = 8;
      }
    break;

    //case 8: leitura da velocidade atual do motor RPM
    case 8:
      Comm_MB.u8id = 1; // slave address
      Comm_MB.u8fct = 3; // function code (this one is registers read)
      Comm_MB.u16RegAdd = 5893; // start address in slave
      Comm_MB.u16CoilsNo = 1; // number of elements (coils or registers) to read
      Comm_MB.au16reg = VAR_Rpm_Act; // pointer to a memory array in the CPU
      master.query(Comm_MB); // send query (only once)
      u8state++;
    break;

    case 9:
      master.poll(); // check incoming messages
      if (master.getState() == COM_IDLE) {
        FUNC_MB_Read();
        u8state = 10;
      }
    break;
    
    //case 10: comandos para o inversor  
    case 10:
      FUNC_MB_Write();
      Comm_MB.u8id = 1; // slave address
      Comm_MB.u8fct = 16; // function code (this one is registers write)
      Comm_MB.u16RegAdd = 8192; // start address in slave
      Comm_MB.u16CoilsNo = 1; // number of elements (coils or registers) to write
      Comm_MB.au16reg = VAR_Comandos; // pointer to a memory array in the CPU
      master.query(Comm_MB); // send query (only once)
      u8state++;
    break;

    case 11:
      master.poll(); // check incoming messages
      if (master.getState() == COM_IDLE) {
        u8state = 12;
      }
    break;

    //case 12: comando de velocidade
    case 12:
      FUNC_MB_Write();
      Comm_MB.u8id = 1; // slave address
      Comm_MB.u8fct = 16; // function code (this one is registers read)
      Comm_MB.u16RegAdd = 8193; // start address in slave
      Comm_MB.u16CoilsNo = 1; // number of elements (coils or registers) to read
      Comm_MB.au16reg = VAR_Speed; // pointer to a memory array in the CPU
      master.query(Comm_MB); // send query (only once)
      u8state++;
    break;

    case 13:
      master.poll(); // check incoming messages
      if (master.getState() == COM_IDLE) {
        u8state = 14;
      }
    break;
    
    //case 14: leitura dos erros do inversor
    case 14:
      Comm_MB.u8id = 1; // slave address
      Comm_MB.u8fct = 3; // function code (this one is registers read)
      Comm_MB.u16RegAdd = 8450; // start address in slave
      Comm_MB.u16CoilsNo = 1; // number of elements (coils or registers) to read
      Comm_MB.au16reg = VAR_Falha; // pointer to a memory array in the CPU
      master.query(Comm_MB); // send query (only once)
      u8state++;
    break;

    case 15:
      master.poll(); // check incoming messages
      if (master.getState() == COM_IDLE) {
        FUNC_MB_Read();
        u8state = 0;
      }
    break;
  }
}
